
'// RFM69/SX1231 Internal registers addresses
'//**************************************************
Const Reg_fifo = &H00
Const Reg_opmode = &H01
Const Reg_datamodul = &H02
Const Reg_bitratemsb = &H03
Const Reg_bitratelsb = &H04
Const Reg_fdevmsb = &H05
Const Reg_fdevlsb = &H06
Const Reg_frfmsb = &H07
Const Reg_frfmid = &H08
Const Reg_frflsb = &H09
Const Reg_osc1 = &H0A
Const Reg_afcctrl = &H0B
Const Reg_lowbat = &H0C
Const Reg_listen1 = &H0D
Const Reg_listen2 = &H0E
Const Reg_listen3 = &H0F
Const Reg_version = &H10
Const Reg_palevel = &H11
Const Reg_paramp = &H12
Const Reg_ocp = &H13
Const Reg_agcref = &H14                                     '// not present on RFM69/SX1231
Const Reg_agcthresh1 = &H15                                 '// not present on RFM69/SX1231
Const Reg_agcthresh2 = &H16                                 '// not present on RFM69/SX1231
Const Reg_agcthresh3 = &H17                                 '// not present on RFM69/SX1231
Const Reg_lna = &H18
Const Reg_rxbw = &H19
Const Reg_afcbw = &H1A
Const Reg_ookpeak = &H1B
Const Reg_ookavg = &H1C
Const Reg_ookfix = &H1D
Const Reg_afcfei = &H1E
Const Reg_afcmsb = &H1F
Const Reg_afclsb = &H20
Const Reg_feimsb = &H21
Const Reg_feilsb = &H22
Const Reg_rssiconfig = &H23
Const Reg_rssivalue = &H24
Const Reg_diomapping1 = &H25
Const Reg_diomapping2 = &H26
Const Reg_irqflags1 = &H27
Const Reg_irqflags2 = &H28
Const Reg_rssithresh = &H29
Const Reg_rxtimeout1 = &H2A
Const Reg_rxtimeout2 = &H2B
Const Reg_preamblemsb = &H2C
Const Reg_preamblelsb = &H2D
Const Reg_syncconfig = &H2E
Const Reg_syncvalue1 = &H2F
Const Reg_syncvalue2 = &H30
Const Reg_syncvalue3 = &H31
Const Reg_syncvalue4 = &H32
Const Reg_syncvalue5 = &H33
Const Reg_syncvalue6 = &H34
Const Reg_syncvalue7 = &H35
Const Reg_syncvalue8 = &H36
Const Reg_packetconfig1 = &H37
Const Reg_payloadlength = &H38
Const Reg_nodeadrs = &H39
Const Reg_broadcastadrs = &H3A
Const Reg_automodes = &H3B
Const Reg_fifothresh = &H3C
Const Reg_packetconfig2 = &H3D
Const Reg_aeskey1 = &H3E
Const Reg_aeskey2 = &H3F
Const Reg_aeskey3 = &H40
Const Reg_aeskey4 = &H41
Const Reg_aeskey5 = &H42
Const Reg_aeskey6 = &H43
Const Reg_aeskey7 = &H44
Const Reg_aeskey8 = &H45
Const Reg_aeskey9 = &H46
Const Reg_aeskey10 = &H47
Const Reg_aeskey11 = &H48
Const Reg_aeskey12 = &H49
Const Reg_aeskey13 = &H4A
Const Reg_aeskey14 = &H4B
Const Reg_aeskey15 = &H4C
Const Reg_aeskey16 = &H4D
Const Reg_temp1 = &H4E
Const Reg_temp2 = &H4F
Const Reg_testlna = &H58
Const Reg_testpa1 = &H5A                                    '// only present on RFM69HW/SX1231H
Const Reg_testpa2 = &H5C                                    '// only present on RFM69HW/SX1231H
Const Reg_testdagc = &H6F

'//******************************************************
'// RF69/SX1231 bit control definition
'//******************************************************

'// RegOpMode
Const Opmode_sequencer_off = &H80
Const Opmode_sequencer_on = &H00                            '// Default

Const Opmode_listen_on = &H40
Const Opmode_listen_off = &H00                              '// Default

Const Opmode_listenabort = &H20

Const Opmode_sleep = &H00
Const Opmode_standby = &H04                                 '// Default
Const Opmode_synthesizer = &H08
Const Opmode_transmitter = &H0C
Const Opmode_receiver = &H10


'// RegDataModul
Const Datamodul_datamode_packet = &H00                      '// Default
Const Datamodul_datamode_continuous = &H40
'DATAMODUL_DATAMODE_CONTINUOUSNOBSYNC = &H60

Const Datamodul_modulationtype_fsk = &H00                   '// Default
Const Datamodul_modulationtype_ook = &H08

Const Datamodul_modulationshaping_00 = &H00                 '// Default
Const Datamodul_modulationshaping_01 = &H01
Const Datamodul_modulationshaping_10 = &H02
Const Datamodul_modulationshaping_11 = &H03


'// RegBitRate (bits/sec) example bit rates
Const Bitratemsb_1200 = &H68
Const Bitratelsb_1200 = &H2B
Const Bitratemsb_2400 = &H34
Const Bitratelsb_2400 = &H15
Const Bitratemsb_4800 = &H1A                                '// Default
Const Bitratelsb_4800 = &H0B                                '// Default
Const Bitratemsb_9600 = &H0D
Const Bitratelsb_9600 = &H05
Const Bitratemsb_19200 = &H06
Const Bitratelsb_19200 = &H83
Const Bitratemsb_38400 = &H03
Const Bitratelsb_38400 = &H41

Const Bitratemsb_38323 = &H03
Const Bitratelsb_38323 = &H43

Const Bitratemsb_34482 = &H03
Const Bitratelsb_34482 = &HA0

Const Bitratemsb_76800 = &H01
Const Bitratelsb_76800 = &HA1
Const Bitratemsb_153600 = &H00
Const Bitratelsb_153600 = &HD0
Const Bitratemsb_57600 = &H02
Const Bitratelsb_57600 = &H2C
Const Bitratemsb_115200 = &H01
Const Bitratelsb_115200 = &H16
Const Bitratemsb_12500 = &H0A
Const Bitratelsb_12500 = &H00
Const Bitratemsb_25000 = &H05
Const Bitratelsb_25000 = &H00
Const Bitratemsb_50000 = &H02
Const Bitratelsb_50000 = &H80
Const Bitratemsb_100000 = &H01
Const Bitratelsb_100000 = &H40
Const Bitratemsb_150000 = &H00
Const Bitratelsb_150000 = &HD5
Const Bitratemsb_200000 = &H00
Const Bitratelsb_200000 = &HA0
Const Bitratemsb_250000 = &H00
Const Bitratelsb_250000 = &H80
Const Bitratemsb_300000 = &H00
Const Bitratelsb_300000 = &H6B
Const Bitratemsb_32768 = &H03
Const Bitratelsb_32768 = &HD1
'// custom bit rates
Const Bitratemsb_55555 = &H02
Const Bitratelsb_55555 = &H40
Const Bitratemsb_200kbps = &H00
Const Bitratelsb_200kbps = &HA0


'// RegFdev - frequency deviation (Hz)
Const Fdevmsb_2000 = &H00
Const Fdevlsb_2000 = &H21
Const Fdevmsb_5000 = &H00                                   '// Default
Const Fdevlsb_5000 = &H52                                   '// Default
Const Fdevmsb_7500 = &H00
Const Fdevlsb_7500 = &H7B
Const Fdevmsb_10000 = &H00
Const Fdevlsb_10000 = &HA4
Const Fdevmsb_15000 = &H00
Const Fdevlsb_15000 = &HF6
Const Fdevmsb_20000 = &H01
Const Fdevlsb_20000 = &H48
Const Fdevmsb_25000 = &H01
Const Fdevlsb_25000 = &H9A
Const Fdevmsb_30000 = &H01
Const Fdevlsb_30000 = &HEC
Const Fdevmsb_35000 = &H02
Const Fdevlsb_35000 = &H3D
Const Fdevmsb_40000 = &H02
Const Fdevlsb_40000 = &H8F
Const Fdevmsb_45000 = &H02
Const Fdevlsb_45000 = &HE1
Const Fdevmsb_50000 = &H03
Const Fdevlsb_50000 = &H33
Const Fdevmsb_55000 = &H03
Const Fdevlsb_55000 = &H85
Const Fdevmsb_60000 = &H03
Const Fdevlsb_60000 = &HD7
Const Fdevmsb_65000 = &H04
Const Fdevlsb_65000 = &H29
Const Fdevmsb_70000 = &H04
Const Fdevlsb_70000 = &H7B
Const Fdevmsb_75000 = &H04
Const Fdevlsb_75000 = &HCD
Const Fdevmsb_80000 = &H05
Const Fdevlsb_80000 = &H1F
Const Fdevmsb_85000 = &H05
Const Fdevlsb_85000 = &H71
Const Fdevmsb_90000 = &H05
Const Fdevlsb_90000 = &HC3
Const Fdevmsb_95000 = &H06
Const Fdevlsb_95000 = &H14
Const Fdevmsb_100000 = &H06
Const Fdevlsb_100000 = &H66
Const Fdevmsb_110000 = &H07
Const Fdevlsb_110000 = &H0A
Const Fdevmsb_120000 = &H07
Const Fdevlsb_120000 = &HAE
Const Fdevmsb_130000 = &H08
Const Fdevlsb_130000 = &H52
Const Fdevmsb_140000 = &H08
Const Fdevlsb_140000 = &HF6
Const Fdevmsb_150000 = &H09
Const Fdevlsb_150000 = &H9A
Const Fdevmsb_160000 = &H0A
Const Fdevlsb_160000 = &H3D
Const Fdevmsb_170000 = &H0A
Const Fdevlsb_170000 = &HE1
Const Fdevmsb_180000 = &H0B
Const Fdevlsb_180000 = &H85
Const Fdevmsb_190000 = &H0C
Const Fdevlsb_190000 = &H29
Const Fdevmsb_200000 = &H0C
Const Fdevlsb_200000 = &HCD
Const Fdevmsb_210000 = &H0D
Const Fdevlsb_210000 = &H71
Const Fdevmsb_220000 = &H0E
Const Fdevlsb_220000 = &H14
Const Fdevmsb_230000 = &H0E
Const Fdevlsb_230000 = &HB8
Const Fdevmsb_240000 = &H0F
Const Fdevlsb_240000 = &H5C
Const Fdevmsb_250000 = &H10
Const Fdevlsb_250000 = &H00
Const Fdevmsb_260000 = &H10
Const Fdevlsb_260000 = &HA4
Const Fdevmsb_270000 = &H11
Const Fdevlsb_270000 = &H48
Const Fdevmsb_280000 = &H11
Const Fdevlsb_280000 = &HEC
Const Fdevmsb_290000 = &H12
Const Fdevlsb_290000 = &H8F
Const Fdevmsb_300000 = &H13
Const Fdevlsb_300000 = &H33


'// RegFrf (MHz) - carrier frequency
'// 315Mhz band
Const Frfmsb_314 = &H4E
Const Frfmid_314 = &H80
Const Frflsb_314 = &H00
Const Frfmsb_315 = &H4E
Const Frfmid_315 = &HC0
Const Frflsb_315 = &H00
Const Frfmsb_316 = &H4F
Const Frfmid_316 = &H00
Const Frflsb_316 = &H00
'// 433mhz band
Const Frfmsb_433 = &H6C
Const Frfmid_433 = &H40
Const Frflsb_433 = &H00
Const Frfmsb_434 = &H6C
Const Frfmid_434 = &H80
Const Frflsb_434 = &H00
Const Frfmsb_435 = &H6C
Const Frfmid_435 = &HC0
Const Frflsb_435 = &H00
'// 868Mhz band
Const Frfmsb_863 = &HD7
Const Frfmid_863 = &HC0
Const Frflsb_863 = &H00
Const Frfmsb_864 = &HD8
Const Frfmid_864 = &H00
Const Frflsb_864 = &H00
Const Frfmsb_865 = &HD8
Const Frfmid_865 = &H40
Const Frflsb_865 = &H00
Const Frfmsb_866 = &HD8
Const Frfmid_866 = &H80
Const Frflsb_866 = &H00
Const Frfmsb_867 = &HD8
Const Frfmid_867 = &HC0
Const Frflsb_867 = &H00
Const Frfmsb_868 = &HD9
Const Frfmid_868 = &H00
Const Frflsb_868 = &H00
Const Frfmsb_869 = &HD9
Const Frfmid_869 = &H40
Const Frflsb_869 = &H00
Const Frfmsb_870 = &HD9
Const Frfmid_870 = &H80
Const Frflsb_870 = &H00
'// 915Mhz band
Const Frfmsb_902 = &HE1
Const Frfmid_902 = &H80
Const Frflsb_902 = &H00
Const Frfmsb_903 = &HE1
Const Frfmid_903 = &HC0
Const Frflsb_903 = &H00
Const Frfmsb_904 = &HE2
Const Frfmid_904 = &H00
Const Frflsb_904 = &H00
Const Frfmsb_905 = &HE2
Const Frfmid_905 = &H40
Const Frflsb_905 = &H00
Const Frfmsb_906 = &HE2
Const Frfmid_906 = &H80
Const Frflsb_906 = &H00
Const Frfmsb_907 = &HE2
Const Frfmid_907 = &HC0
Const Frflsb_907 = &H00
Const Frfmsb_908 = &HE3
Const Frfmid_908 = &H00
Const Frflsb_908 = &H00
Const Frfmsb_909 = &HE3
Const Frfmid_909 = &H40
Const Frflsb_909 = &H00
Const Frfmsb_910 = &HE3
Const Frfmid_910 = &H80
Const Frflsb_910 = &H00
Const Frfmsb_911 = &HE3
Const Frfmid_911 = &HC0
Const Frflsb_911 = &H00
Const Frfmsb_912 = &HE4
Const Frfmid_912 = &H00
Const Frflsb_912 = &H00
Const Frfmsb_913 = &HE4
Const Frfmid_913 = &H40
Const Frflsb_913 = &H00
Const Frfmsb_914 = &HE4
Const Frfmid_914 = &H80
Const Frflsb_914 = &H00
Const Frfmsb_915 = &HE4                                     '// Default
Const Frfmid_915 = &HC0                                     '// Default
Const Frflsb_915 = &H00                                     '// Default
Const Frfmsb_916 = &HE5
Const Frfmid_916 = &H00
Const Frflsb_916 = &H00
Const Frfmsb_917 = &HE5
Const Frfmid_917 = &H40
Const Frflsb_917 = &H00
Const Frfmsb_918 = &HE5
Const Frfmid_918 = &H80
Const Frflsb_918 = &H00
Const Frfmsb_919 = &HE5
Const Frfmid_919 = &HC0
Const Frflsb_919 = &H00
Const Frfmsb_920 = &HE6
Const Frfmid_920 = &H00
Const Frflsb_920 = &H00
Const Frfmsb_921 = &HE6
Const Frfmid_921 = &H40
Const Frflsb_921 = &H00
Const Frfmsb_922 = &HE6
Const Frfmid_922 = &H80
Const Frflsb_922 = &H00
Const Frfmsb_923 = &HE6
Const Frfmid_923 = &HC0
Const Frflsb_923 = &H00
Const Frfmsb_924 = &HE7
Const Frfmid_924 = &H00
Const Frflsb_924 = &H00
Const Frfmsb_925 = &HE7
Const Frfmid_925 = &H40
Const Frflsb_925 = &H00
Const Frfmsb_926 = &HE7
Const Frfmid_926 = &H80
Const Frflsb_926 = &H00
Const Frfmsb_927 = &HE7
Const Frfmid_927 = &HC0
Const Frflsb_927 = &H00
Const Frfmsb_928 = &HE8
Const Frfmid_928 = &H00
Const Frflsb_928 = &H00


'// RegOsc1
Const Osc1_rccal_start = &H80
Const Osc1_rccal_done = &H40


'// RegAfcCtrl
Const Afcctrl_lowbeta_off = &H00                            '// Default
Const Afcctrl_lowbeta_on = &H20


'// RegLowBat
Const Lowbat_monitor = &H10
Const Lowbat_on = &H08
Const Lowbat_off = &H00                                     '// Default

Const Lowbat_trim_1695 = &H00
Const Lowbat_trim_1764 = &H01
Const Lowbat_trim_1835 = &H02                               '// Default
Const Lowbat_trim_1905 = &H03
Const Lowbat_trim_1976 = &H04
Const Lowbat_trim_2045 = &H05
Const Lowbat_trim_2116 = &H06
Const Lowbat_trim_2185 = &H07


'// RegListen1
Const Listen1_resol_64 = &H50
Const Listen1_resol_4100 = &HA0                             '// Default
Const Listen1_resol_262000 = &HF0

Const Listen1_resol_idle_64 = &H40
Const Listen1_resol_idle_4100 = &H80                        '// Default
Const Listen1_resol_idle_262000 = &HC0

Const Listen1_resol_rx_64 = &H10
Const Listen1_resol_rx_4100 = &H20                          '// Default
Const Listen1_resol_rx_262000 = &H30

Const Listen1_criteria_rssi = &H00                          '// Default
Const Listen1_criteria_rssiandsync = &H08

Const Listen1_end_00 = &H00
Const Listen1_end_01 = &H02                                 '// Default
Const Listen1_end_10 = &H04


'// RegListen2
Const Listen2_coefidle_value = &HF5                         '// Default


'// RegListen3
Const Listen3_coefrx_value = &H20                           '// Default


'// RegVersion
Const Version_ver = &H24                                    '// Default


'// RegPaLevel
Const Palevel_pa0_on = &H80                                 '// Default
Const Palevel_pa0_off = &H00
Const Palevel_pa1_on = &H40
Const Palevel_pa1_off = &H00                                '// Default
Const Palevel_pa2_on = &H20
Const Palevel_pa2_off = &H00                                '// Default

Const Palevel_outputpower_00000 = &H00
Const Palevel_outputpower_00001 = &H01
Const Palevel_outputpower_00010 = &H02
Const Palevel_outputpower_00011 = &H03
Const Palevel_outputpower_00100 = &H04
Const Palevel_outputpower_00101 = &H05
Const Palevel_outputpower_00110 = &H06
Const Palevel_outputpower_00111 = &H07
Const Palevel_outputpower_01000 = &H08
Const Palevel_outputpower_01001 = &H09
Const Palevel_outputpower_01010 = &H0A
Const Palevel_outputpower_01011 = &H0B
Const Palevel_outputpower_01100 = &H0C
Const Palevel_outputpower_01101 = &H0D
Const Palevel_outputpower_01110 = &H0E
Const Palevel_outputpower_01111 = &H0F
Const Palevel_outputpower_10000 = &H10
Const Palevel_outputpower_10001 = &H11
Const Palevel_outputpower_10010 = &H12
Const Palevel_outputpower_10011 = &H13
Const Palevel_outputpower_10100 = &H14
Const Palevel_outputpower_10101 = &H15
Const Palevel_outputpower_10110 = &H16
Const Palevel_outputpower_10111 = &H17
Const Palevel_outputpower_11000 = &H18
Const Palevel_outputpower_11001 = &H19
Const Palevel_outputpower_11010 = &H1A
Const Palevel_outputpower_11011 = &H1B
Const Palevel_outputpower_11100 = &H1C
Const Palevel_outputpower_11101 = &H1D
Const Palevel_outputpower_11110 = &H1E
Const Palevel_outputpower_11111 = &H1F                      '// Default


'// RegPaRamp
Const Paramp_3400 = &H00
Const Paramp_2000 = &H01
Const Paramp_1000 = &H02
Const Paramp_500 = &H03
Const Paramp_250 = &H04
Const Paramp_125 = &H05
Const Paramp_100 = &H06
Const Paramp_62 = &H07
Const Paramp_50 = &H08
Const Paramp_40 = &H09                                      '// Default
Const Paramp_31 = &H0A
Const Paramp_25 = &H0B
Const Paramp_20 = &H0C
Const Paramp_15 = &H0D
Const Paramp_12 = &H0E
Const Paramp_10 = &H0F


'// RegOcp
Const Ocp_off = &H0F
Const Ocp_on = &H1A                                         '// Default

Const Ocp_trim_45 = &H00
Const Ocp_trim_50 = &H01
Const Ocp_trim_55 = &H02
Const Ocp_trim_60 = &H03
Const Ocp_trim_65 = &H04
Const Ocp_trim_70 = &H05
Const Ocp_trim_75 = &H06
Const Ocp_trim_80 = &H07
Const Ocp_trim_85 = &H08
Const Ocp_trim_90 = &H09
Const Ocp_trim_95 = &H0A                                    '// Default
Const Ocp_trim_100 = &H0B
Const Ocp_trim_105 = &H0C
Const Ocp_trim_110 = &H0D
Const Ocp_trim_115 = &H0E
Const Ocp_trim_120 = &H0F


'// RegAgcRef - not present on RFM69/SX1231
Const Agcref_auto_on = &H40                                 '// Default
Const Agcref_auto_off = &H00

Const Agcref_level_minus80 = &H00                           '// Default
Const Agcref_level_minus81 = &H01
Const Agcref_level_minus82 = &H02
Const Agcref_level_minus83 = &H03
Const Agcref_level_minus84 = &H04
Const Agcref_level_minus85 = &H05
Const Agcref_level_minus86 = &H06
Const Agcref_level_minus87 = &H07
Const Agcref_level_minus88 = &H08
Const Agcref_level_minus89 = &H09
Const Agcref_level_minus90 = &H0A
Const Agcref_level_minus91 = &H0B
Const Agcref_level_minus92 = &H0C
Const Agcref_level_minus93 = &H0D
Const Agcref_level_minus94 = &H0E
Const Agcref_level_minus95 = &H0F
Const Agcref_level_minus96 = &H10
Const Agcref_level_minus97 = &H11
Const Agcref_level_minus98 = &H12
Const Agcref_level_minus99 = &H13
Const Agcref_level_minus100 = &H14
Const Agcref_level_minus101 = &H15
Const Agcref_level_minus102 = &H16
Const Agcref_level_minus103 = &H17
Const Agcref_level_minus104 = &H18
Const Agcref_level_minus105 = &H19
Const Agcref_level_minus106 = &H1A
Const Agcref_level_minus107 = &H1B
Const Agcref_level_minus108 = &H1C
Const Agcref_level_minus109 = &H1D
Const Agcref_level_minus110 = &H1E
Const Agcref_level_minus111 = &H1F
Const Agcref_level_minus112 = &H20
Const Agcref_level_minus113 = &H21
Const Agcref_level_minus114 = &H22
Const Agcref_level_minus115 = &H23
Const Agcref_level_minus116 = &H24
Const Agcref_level_minus117 = &H25
Const Agcref_level_minus118 = &H26
Const Agcref_level_minus119 = &H27
Const Agcref_level_minus120 = &H28
Const Agcref_level_minus121 = &H29
Const Agcref_level_minus122 = &H2A
Const Agcref_level_minus123 = &H2B
Const Agcref_level_minus124 = &H2C
Const Agcref_level_minus125 = &H2D
Const Agcref_level_minus126 = &H2E
Const Agcref_level_minus127 = &H2F
Const Agcref_level_minus128 = &H30
Const Agcref_level_minus129 = &H31
Const Agcref_level_minus130 = &H32
Const Agcref_level_minus131 = &H33
Const Agcref_level_minus132 = &H34
Const Agcref_level_minus133 = &H35
Const Agcref_level_minus134 = &H36
Const Agcref_level_minus135 = &H37
Const Agcref_level_minus136 = &H38
Const Agcref_level_minus137 = &H39
Const Agcref_level_minus138 = &H3A
Const Agcref_level_minus139 = &H3B
Const Agcref_level_minus140 = &H3C
Const Agcref_level_minus141 = &H3D
Const Agcref_level_minus142 = &H3E
Const Agcref_level_minus143 = &H3F


'// RegAgcThresh1 - not present on RFM69/SX1231
Const Agcthresh1_snrmargin_000 = &H00
Const Agcthresh1_snrmargin_001 = &H20
Const Agcthresh1_snrmargin_010 = &H40
Const Agcthresh1_snrmargin_011 = &H60
Const Agcthresh1_snrmargin_100 = &H80
Const Agcthresh1_snrmargin_101 = &HA0                       '// Default
Const Agcthresh1_snrmargin_110 = &HC0
Const Agcthresh1_snrmargin_111 = &HE0

Const Agcthresh1_step1_0 = &H00
Const Agcthresh1_step1_1 = &H01
Const Agcthresh1_step1_2 = &H02
Const Agcthresh1_step1_3 = &H03
Const Agcthresh1_step1_4 = &H04
Const Agcthresh1_step1_5 = &H05
Const Agcthresh1_step1_6 = &H06
Const Agcthresh1_step1_7 = &H07
Const Agcthresh1_step1_8 = &H08
Const Agcthresh1_step1_9 = &H09
Const Agcthresh1_step1_10 = &H0A
Const Agcthresh1_step1_11 = &H0B
Const Agcthresh1_step1_12 = &H0C
Const Agcthresh1_step1_13 = &H0D
Const Agcthresh1_step1_14 = &H0E
Const Agcthresh1_step1_15 = &H0F
Const Agcthresh1_step1_16 = &H10                            '// Default
Const Agcthresh1_step1_17 = &H11
Const Agcthresh1_step1_18 = &H12
Const Agcthresh1_step1_19 = &H13
Const Agcthresh1_step1_20 = &H14
Const Agcthresh1_step1_21 = &H15
Const Agcthresh1_step1_22 = &H16
Const Agcthresh1_step1_23 = &H17
Const Agcthresh1_step1_24 = &H18
Const Agcthresh1_step1_25 = &H19
Const Agcthresh1_step1_26 = &H1A
Const Agcthresh1_step1_27 = &H1B
Const Agcthresh1_step1_28 = &H1C
Const Agcthresh1_step1_29 = &H1D
Const Agcthresh1_step1_30 = &H1E
Const Agcthresh1_step1_31 = &H1F


'// RegAgcThresh2 - not present on RFM69/SX1231
Const Agcthresh2_step2_0 = &H00
Const Agcthresh2_step2_1 = &H10
Const Agcthresh2_step2_2 = &H20
Const Agcthresh2_step2_3 = &H30                             '// XXX wrong -- Default
Const Agcthresh2_step2_4 = &H40
Const Agcthresh2_step2_5 = &H50
Const Agcthresh2_step2_6 = &H60
Const Agcthresh2_step2_7 = &H70                             '// default
Const Agcthresh2_step2_8 = &H80
Const Agcthresh2_step2_9 = &H90
Const Agcthresh2_step2_10 = &HA0
Const Agcthresh2_step2_11 = &HB0
Const Agcthresh2_step2_12 = &HC0
Const Agcthresh2_step2_13 = &HD0
Const Agcthresh2_step2_14 = &HE0
Const Agcthresh2_step2_15 = &HF0

Const Agcthresh2_step3_0 = &H00
Const Agcthresh2_step3_1 = &H01
Const Agcthresh2_step3_2 = &H02
Const Agcthresh2_step3_3 = &H03
Const Agcthresh2_step3_4 = &H04
Const Agcthresh2_step3_5 = &H05
Const Agcthresh2_step3_6 = &H06
Const Agcthresh2_step3_7 = &H07
Const Agcthresh2_step3_8 = &H08
Const Agcthresh2_step3_9 = &H09
Const Agcthresh2_step3_10 = &H0A
Const Agcthresh2_step3_11 = &H0B                            '// Default
Const Agcthresh2_step3_12 = &H0C
Const Agcthresh2_step3_13 = &H0D
Const Agcthresh2_step3_14 = &H0E
Const Agcthresh2_step3_15 = &H0F


'// RegAgcThresh3 - not present on RFM69/SX1231
Const Agcthresh3_step4_0 = &H00
Const Agcthresh3_step4_1 = &H10
Const Agcthresh3_step4_2 = &H20
Const Agcthresh3_step4_3 = &H30
Const Agcthresh3_step4_4 = &H40
Const Agcthresh3_step4_5 = &H50
Const Agcthresh3_step4_6 = &H60
Const Agcthresh3_step4_7 = &H70
Const Agcthresh3_step4_8 = &H80
Const Agcthresh3_step4_9 = &H90                             '// Default
Const Agcthresh3_step4_10 = &HA0
Const Agcthresh3_step4_11 = &HB0
Const Agcthresh3_step4_12 = &HC0
Const Agcthresh3_step4_13 = &HD0
Const Agcthresh3_step4_14 = &HE0
Const Agcthresh3_step4_15 = &HF0

Const Agcthresh3_step5_0 = &H00
Const Agcthresh3_step5_1 = &H01
Const Agcthresh3_step5_2 = &H02
Const Agcthresh3_step5_3 = &H03
Const Agcthresh3_step5_4 = &H04
Const Agcthresh3_step5_5 = &H05
Const Agcthresh3_step5_6 = &H06
Const Agcthresh3_step5_7 = &H07
Const Agcthres33_step5_8 = &H08
Const Agcthresh3_step5_9 = &H09
Const Agcthresh3_step5_10 = &H0A
Const Agcthresh3_step5_11 = &H0B                            '// Default
Const Agcthresh3_step5_12 = &H0C
Const Agcthresh3_step5_13 = &H0D
Const Agcthresh3_step5_14 = &H0E
Const Agcthresh3_step5_15 = &H0F


'// RegLna
Const Lna_zin_50 = &H00                                     '// Reset value
Const Lna_zin_200 = &H80                                    '// Recommended default

Const Lna_lowpower_off = &H00                               '// Default
Const Lna_lowpower_on = &H40

Const Lna_currentgain = &H08

Const Lna_gainselect_auto = &H00                            '// Default
Const Lna_gainselect_max = &H01
Const Lna_gainselect_maxminus6 = &H02
Const Lna_gainselect_maxminus12 = &H03
Const Lna_gainselect_maxminus24 = &H04
Const Lna_gainselect_maxminus36 = &H05
Const Lna_gainselect_maxminus48 = &H06


'// RegRxBw
Const Rxbw_dccfreq_000 = &H00
Const Rxbw_dccfreq_001 = &H20
Const Rxbw_dccfreq_010 = &H40                               '// Recommended default
Const Rxbw_dccfreq_011 = &H60
Const Rxbw_dccfreq_100 = &H80                               '// Reset value
Const Rxbw_dccfreq_101 = &HA0
Const Rxbw_dccfreq_110 = &HC0
Const Rxbw_dccfreq_111 = &HE0

Const Rxbw_mant_16 = &H00                                   '// Reset value
Const Rxbw_mant_20 = &H08
Const Rxbw_mant_24 = &H10                                   '// Recommended default

Const Rxbw_exp_0 = &H00
Const Rxbw_exp_1 = &H01
Const Rxbw_exp_2 = &H02
Const Rxbw_exp_3 = &H03
Const Rxbw_exp_4 = &H04
Const Rxbw_exp_5 = &H05                                     '// Recommended default
Const Rxbw_exp_6 = &H06                                     '// Reset value
Const Rxbw_exp_7 = &H07


'// RegAfcBw
Const Afcbw_dccfreqafc_000 = &H00
Const Afcbw_dccfreqafc_001 = &H20
Const Afcbw_dccfreqafc_010 = &H40
Const Afcbw_dccfreqafc_011 = &H60
Const Afcbw_dccfreqafc_100 = &H80                           '// Default
Const Afcbw_dccfreqafc_101 = &HA0
Const Afcbw_dccfreqafc_110 = &HC0
Const Afcbw_dccfreqafc_111 = &HE0

Const Afcbw_mantafc_16 = &H00
Const Afcbw_mantafc_20 = &H08                               '// Default
Const Afcbw_mantafc_24 = &H10

Const Afcbw_expafc_0 = &H00
Const Afcbw_expafc_1 = &H01
Const Afcbw_expafc_2 = &H02                                 '// Reset value
Const Afcbw_expafc_3 = &H03                                 '// Recommended default
Const Afcbw_expafc_4 = &H04
Const Afcbw_expafc_5 = &H05
Const Afcbw_expafc_6 = &H06
Const Afcbw_expafc_7 = &H07


'// RegOokPeak
Const Ookpeak_threshtype_fixed = &H00
Const Ookpeak_threshtype_peak = &H40                        '// Default
Const Ookpeak_threshtype_average = &H80

Const Ookpeak_peakthreshstep_000 = &H00                     '// Default
Const Ookpeak_peakthreshstep_001 = &H08
Const Ookpeak_peakthreshstep_010 = &H10
Const Ookpeak_peakthreshstep_011 = &H18
Const Ookpeak_peakthreshstep_100 = &H20
Const Ookpeak_peakthreshstep_101 = &H28
Const Ookpeak_peakthreshstep_110 = &H30
Const Ookpeak_peakthreshstep_111 = &H38

Const Ookpeak_peakthreshdec_000 = &H00                      '// Default
Const Ookpeak_peakthreshdec_001 = &H01
Const Ookpeak_peakthreshdec_010 = &H02
Const Ookpeak_peakthreshdec_011 = &H03
Const Ookpeak_peakthreshdec_100 = &H04
Const Ookpeak_peakthreshdec_101 = &H05
Const Ookpeak_peakthreshdec_110 = &H06
Const Ookpeak_peakthreshdec_111 = &H07


'// RegOokAvg
Const Ookavg_averagethreshfilt_00 = &H00
Const Ookavg_averagethreshfilt_01 = &H40
Const Ookavg_averagethreshfilt_10 = &H80                    '// Default
Const Ookavg_averagethreshfilt_11 = &HC0


'// RegOokFix
Const Ookfix_fixedthresh_value = &H06                       '// Default


'// RegAfcFei
Const Afcfei_fei_done = &H40
Const Afcfei_fei_start = &H20
Const Afcfei_afc_done = &H10
Const Afcfei_afcautoclear_on = &H08
Const Afcfei_afcautoclear_off = &H00                        '// Default

Const Afcfei_afcauto_on = &H04
Const Afcfei_afcauto_off = &H00                             '// Default

Const Afcfei_afc_clear = &H02
Const Afcfei_afc_start = &H01


'// RegRssiConfig
Const Rssi_fastrx_on = &H08                                 '// not present on RFM69/SX1231
Const Rssi_fastrx_off = &H00                                '// Default

Const Rssi_done = &H02
Const Rssi_start = &H01


'// RegDioMapping1
Const Diomapping1_dio0_00 = &H00                            '// Default
Const Diomapping1_dio0_01 = &H40
Const Diomapping1_dio0_10 = &H80
Const Diomapping1_dio0_11 = &HC0

Const Diomapping1_dio1_00 = &H00                            '// Default
Const Diomapping1_dio1_01 = &H10
Const Diomapping1_dio1_10 = &H20
Const Diomapping1_dio1_11 = &H30

Const Diomapping1_dio2_00 = &H00                            '// Default
Const Diomapping1_dio2_01 = &H04
Const Diomapping1_dio2_10 = &H08
Const Diomapping1_dio2_11 = &H0C

Const Diomapping1_dio3_00 = &H00                            '// Default
Const Diomapping1_dio3_01 = &H01
Const Diomapping1_dio3_10 = &H02
Const Diomapping1_dio3_11 = &H03


'// RegDioMapping2
Const Diomapping2_dio4_00 = &H00                            '// Default
Const Diomapping2_dio4_01 = &H40
Const Diomapping2_dio4_10 = &H80
Const Diomapping2_dio4_11 = &HC0

Const Diomapping2_dio5_00 = &H00                            '// Default
Const Diomapping2_dio5_01 = &H10
Const Diomapping2_dio5_10 = &H20
Const Diomapping2_dio5_11 = &H30

Const Diomapping2_clkout_32 = &H00
Const Diomapping2_clkout_16 = &H01
Const Diomapping2_clkout_8 = &H02
Const Diomapping2_clkout_4 = &H03
Const Diomapping2_clkout_2 = &H04
Const Diomapping2_clkout_1 = &H05                           '// Reset value
Const Diomapping2_clkout_rc = &H06
Const Diomapping2_clkout_off = &H07                         '// Recommended default


'// RegIrqFlags1
Const Irqflags1_modeready = &H80
Const Irqflags1_rxready = &H40
Const Irqflags1_txready = &H20
Const Irqflags1_plllock = &H10
Const Irqflags1_rssi = &H08
Const Irqflags1_timeout = &H04
Const Irqflags1_automode = &H02
Const Irqflags1_syncaddressmatch = &H01


'// RegIrqFlags2
Const Irqflags2_fifofull = &H80
Const Irqflags2_fifonotempty = &H40
Const Irqflags2_fifolevel = &H20
Const Irqflags2_fifooverrun = &H10
Const Irqflags2_packetsent = &H08
Const Irqflags2_payloadready = &H04
Const Irqflags2_crcok = &H02
Const Irqflags2_lowbat = &H01                               '// not present on RFM69/SX1231


'// RegRssiThresh
Const Rssithresh_value = &HE4                               '// Default


'// RegRxTimeout1
Const Rxtimeout1_rxstart_value = &H00                       '// Default


'// RegRxTimeout2
Const Rxtimeout2_rssithresh_value = &H00                    '// Default


'// RegPreamble
Const Preamblesize_msb_value = &H00                         '// Default
Const Preamblesize_lsb_value = &H03                         '// Default


'// RegSyncConfig
Const Sync_on = &H80                                        '// Default
Const Sync_off = &H00

Const Sync_fifofill_auto = &H00                             '// Default -- when sync interrupt occurs
Const Sync_fifofill_manual = &H40

Const Sync_size_1 = &H00
Const Sync_size_2 = &H08
Const Sync_size_3 = &H10
Const Sync_size_4 = &H18                                    '// Default
Const Sync_size_5 = &H20
Const Sync_size_6 = &H28
Const Sync_size_7 = &H30
Const Sync_size_8 = &H38

Const Sync_tol_0 = &H00                                     '// Default
Const Sync_tol_1 = &H01
Const Sync_tol_2 = &H02
Const Sync_tol_3 = &H03
Const Sync_tol_4 = &H04
Const Sync_tol_5 = &H05
Const Sync_tol_6 = &H06
Const Sync_tol_7 = &H07


'// RegSyncValue1-8
Const Sync_byte1_value = &H00                               '// Default
Const Sync_byte2_value = &H00                               '// Default
Const Sync_byte3_value = &H00                               '// Default
Const Sync_byte4_value = &H00                               '// Default
Const Sync_byte5_value = &H00                               '// Default
Const Sync_byte6_value = &H00                               '// Default
Const Sync_byte7_value = &H00                               '// Default
Const Sync_byte8_value = &H00                               '// Default


'// RegPacketConfig1
Const Packet1_format_fixed = &H00                           '// Default
Const Packet1_format_variable = &H80

Const Packet1_dcfree_off = &H00                             '// Default
Const Packet1_dcfree_manchester = &H20
Const Packet1_dcfree_whitening = &H40

Const Packet1_crc_on = &H10                                 '// Default
Const Packet1_crc_off = &H00

Const Packet1_crcautoclear_on = &H00                        '// Default
Const Packet1_crcautoclear_off = &H08

Const Packet1_adrsfiltering_off = &H00                      '// Default
Const Packet1_adrsfiltering_node = &H02
'PACKET1_ADRSFILTERING_NODEBROADCAST  = &H04


'// RegPayloadLength
Const Payloadlength_value = &H40                            '// Default


'// RegBroadcastAdrs
Const Broadcastaddress_value = &H00


'// RegAutoModes
Const Automodes_enter_off = &H00                            '// Default
Const Automodes_enter_fifonotempty = &H20
Const Automodes_enter_fifolevel = &H40
Const Automodes_enter_crcok = &H60
Const Automodes_enter_payloadready = &H80
Const Automodes_enter_syncadrsmatch = &HA0
Const Automodes_enter_packetsent = &HC0
Const Automodes_enter_fifoempty = &HE0

Const Automodes_exit_off = &H00                             '// Default
Const Automodes_exit_fifoempty = &H04
Const Automodes_exit_fifolevel = &H08
Const Automodes_exit_crcok = &H0C
Const Automodes_exit_payloadready = &H10
Const Automodes_exit_syncadrsmatch = &H14
Const Automodes_exit_packetsent = &H18
Const Automodes_exit_rxtimeout = &H1C

Const Automodes_intermediate_sleep = &H00                   '// Default
Const Automodes_intermediate_standby = &H01
Const Automodes_intermediate_receiver = &H02
'AUTOMODES_INTERMEDIATE_TRANSMITTER = &H03


'// RegFifoThresh
Const Fifothresh_txstart_fifothresh = &H00                  '// Reset value
Const Fifothresh_txstart_fifonotempty = &H80                '// Recommended default

Const Fifothresh_value = &H0F                               '// Default


'// RegPacketConfig2
Const Packet2_rxrestartdelay_1bit = &H00                    '// Default
Const Packet2_rxrestartdelay_2bits = &H10
Const Packet2_rxrestartdelay_4bits = &H20
Const Packet2_rxrestartdelay_8bits = &H30
Const Packet2_rxrestartdelay_16bits = &H40
Const Packet2_rxrestartdelay_32bits = &H50
Const Packet2_rxrestartdelay_64bits = &H60
Const Packet2_rxrestartdelay_128bits = &H70
Const Packet2_rxrestartdelay_256bits = &H80
Const Packet2_rxrestartdelay_512bits = &H90
Const Packet2_rxrestartdelay_1024bits = &HA0
Const Packet2_rxrestartdelay_2048bits = &HB0
Const Packet2_rxrestartdelay_none = &HC0
Const Packet2_rxrestart = &H04

Const Packet2_autorxrestart_on = &H02                       '// Default
Const Packet2_autorxrestart_off = &H00

Const Packet2_aes_on = &H01
Const Packet2_aes_off = &H00                                '// Default


'// RegAesKey1-16
Const Aeskey1_value = &H00                                  '// Default
Const Aeskey2_value = &H00                                  '// Default
Const Aeskey3_value = &H00                                  '// Default
Const Aeskey4_value = &H00                                  '// Default
Const Aeskey5_value = &H00                                  '// Default
Const Aeskey6_value = &H00                                  '// Default
Const Aeskey7_value = &H00                                  '// Default
Const Aeskey8_value = &H00                                  '// Default
Const Aeskey9_value = &H00                                  '// Default
Const Aeskey10_value = &H00                                 '// Default
Const Aeskey11_value = &H00                                 '// Default
Const Aeskey12_value = &H00                                 '// Default
Const Aeskey13_value = &H00                                 '// Default
Const Aeskey14_value = &H00                                 '// Default
Const Aeskey15_value = &H00                                 '// Default
Const Aeskey16_value = &H00                                 '// Default


'// RegTemp1
Const Temp1_meas_start = &H08
Const Temp1_meas_running = &H04
'// not present on RFM69/SX1231
Const Temp1_adclowpower_on = &H01                           '// Default
Const Temp1_adclowpower_off = &H00

'// RegTestLna
Const Testlna_normal = &H1B
Const Testlna_high_sensitivity = &H2D

'// RegTestDagc
Const Dagc_normal = &H00                                    '// Reset value
Const Dagc_improved_lowbeta1 = &H20
Const Dagc_improved_lowbeta0 = &H30                         '// Recommended default

'// available frequency bands
Const Rf69_315mhz = 31                                      '/ / Non Trivial Values To Avoid Misconfiguration
Const Rf69_433mhz = 43
Const Rf69_868mhz = 86
Const Rf69_915mhz = 91


'Adressdefinitionen fr Register
Dim Reg_h01 as Byte                                         'Reg
Dim Reg_h02 as Byte                                         'Reg
Dim Reg_h03 as Byte                                         'Reg
Dim Reg_h04 as Byte                                         'Reg
Dim Reg_h05 as Byte                                         'Reg
Dim Reg_h06 as Byte                                         'Reg
Dim Reg_h07 as Byte                                         'Reg
Dim Reg_h08 as Byte                                         'Reg
Dim Reg_h09 as Byte                                         'Reg
Dim Reg_h0A as Byte                                         'Reg
Dim Reg_h0B as Byte                                         'Reg
Dim Reg_h0C as Byte                                         'Reg
Dim Reg_h0D as Byte                                         'Reg
Dim Reg_h0E as Byte                                         'Reg
Dim Reg_h0F as Byte                                         'Reg
Dim Reg_h10 as Byte                                         'Reg
Dim Reg_h11 as Byte                                         'Reg
Dim Reg_h12 as Byte                                         'Reg
Dim Reg_h13 as Byte                                         'Reg
Dim Reg_h14 as Byte                                         'Reg
Dim Reg_h15 as Byte                                         'Reg
Dim Reg_h16 as Byte                                         'Reg
Dim Reg_h17 as Byte                                         'Reg
Dim Reg_h18 as Byte                                         'Reg
Dim Reg_h19 as Byte                                         'Reg
Dim Reg_h1A as Byte                                         'Reg
Dim Reg_h1B as Byte                                         'Reg
Dim Reg_h1C as Byte                                         'Reg
Dim Reg_h1D as Byte                                         'Reg
Dim Reg_h1E as Byte                                         'Reg
Dim Reg_h1F as Byte                                         'Reg
Dim Reg_h20 as Byte                                         'Reg
Dim Reg_h21 as Byte                                         'Reg
Dim Reg_h22 as Byte                                         'Reg
Dim Reg_h23 as Byte                                         'Reg
Dim Reg_h24 as Byte                                         'Reg
Dim Reg_h25 as Byte                                         'Reg
Dim Reg_h26 as Byte                                         'Reg
Dim Reg_h27 as Byte                                         'Reg
Dim Reg_h28 as Byte                                         'Reg
Dim Reg_h29 as Byte                                         'Reg
Dim Reg_h2A as Byte                                         'Reg
Dim Reg_h2B as Byte                                         'Reg
Dim Reg_h2C as Byte                                         'Reg
Dim Reg_h2D as Byte                                         'Reg
Dim Reg_h2E as Byte                                         'Reg
Dim Reg_h2F as Byte                                         'Reg
Dim Reg_h30 as Byte                                         'Reg
Dim Reg_h31 as Byte                                         'Reg
Dim Reg_h32 as Byte                                         'Reg
Dim Reg_h33 as Byte                                         'Reg
Dim Reg_h34 as Byte                                         'Reg
Dim Reg_h35 as Byte                                         'Reg
Dim Reg_h36 as Byte                                         'Reg
Dim Reg_h37 as Byte                                         'Reg
Dim Reg_h38 as Byte                                         'Reg
Dim Reg_h39 as Byte                                         'Reg
Dim Reg_h3A as Byte                                         'Reg
Dim Reg_h3B as Byte                                         'Reg
Dim Reg_h3C as Byte                                         'Reg
Dim Reg_h3D as Byte                                         'Reg
Dim Reg_h3E as Byte                                         'Reg
Dim Reg_h3F as Byte                                         'Reg
Dim Reg_h40 as Byte                                         'Reg
Dim Reg_h41 as Byte                                         'Reg
Dim Reg_h42 as Byte                                         'Reg
Dim Reg_h43 as Byte                                         'Reg
Dim Reg_h44 as Byte                                         'Reg
Dim Reg_h45 as Byte                                         'Reg
Dim Reg_h46 as Byte                                         'Reg
Dim Reg_h47 as Byte                                         'Reg
Dim Reg_h48 as Byte                                         'Reg
Dim Reg_h49 as Byte                                         'Reg
Dim Reg_h4A as Byte                                         'Reg
Dim Reg_h4B as Byte                                         'Reg
Dim Reg_h4C as Byte                                         'Reg
Dim Reg_h4D as Byte                                         'Reg
Dim Reg_h4E as Byte                                         'Reg
Dim Reg_h4F as Byte                                         'Reg
Dim Reg_h50 as Byte                                         'Reg
Dim Reg_h51 as Byte                                         'Reg
Dim Reg_h52 as Byte                                         'Reg
Dim Reg_h53 as Byte                                         'Reg
Dim Reg_h54 as Byte                                         'Reg
Dim Reg_h55 as Byte                                         'Reg
Dim Reg_h56 as Byte                                         'Reg
Dim Reg_h57 as Byte                                         'Reg
Dim Reg_h58 as Byte                                         'Reg
Dim Reg_h59 as Byte                                         'Reg
Dim Reg_h5A as Byte                                         'Reg
Dim Reg_h5B as Byte                                         'Reg
Dim Reg_h5C as Byte                                         'Reg
Dim Reg_h5D as Byte                                         'Reg
Dim Reg_h5E as Byte                                         'Reg
Dim Reg_h5F as Byte                                         'Reg
Dim Reg_h60 as Byte                                         'Reg
Dim Reg_h61 as Byte                                         'Reg
Dim Reg_h62 as Byte                                         'Reg
Dim Reg_h63 as Byte                                         'Reg
Dim Reg_h64 as Byte                                         'Reg
Dim Reg_h65 as Byte                                         'Reg
Dim Reg_h66 as Byte                                         'Reg
Dim Reg_h67 as Byte                                         'Reg
Dim Reg_h68 as Byte                                         'Reg
Dim Reg_h69 as Byte                                         'Reg
Dim Reg_h6A as Byte                                         'Reg
Dim Reg_h6B as Byte                                         'Reg
Dim Reg_h6C as Byte                                         'Reg
Dim Reg_h6D as Byte                                         'Reg
Dim Reg_h6E as Byte                                         'Reg
Dim Reg_h6F as Byte                                         'Reg
Dim Reg_h70 as Byte                                         'Reg
Dim Reg_h71 as Byte                                         'Reg
